/**
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2018年3月13日
 */
package com.baofoo.Demo;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.rsa.SignatureUtils;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;

public class SubOderSplitSinglePay{
	/**
	 * 子订单支付类交易（协议支付）
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {				
		String send_time=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());//报文发送日期时间
		
		String ProtocolNo = "1202305171100325470007598320";//签约协议号（确认绑卡返回）
		
		String MemberId = "100028758";//商户号
		String TerminalId = "200004032";//终端号

		String  pfxpath ="D:\\CER_EN_DECODE\\100028758\\bfkey_100028758@@200004032.pfx";//商户私钥 
		String  cerpath = "D:\\CER_EN_DECODE\\100028758\\bfkey_100028758@@200004032.cer";//宝付公钥
		String  pfxpwd = "100028758_757487";//私钥密码
		
		String MainTransId="TID1684294161597";//母单 商户订单号
		String MainMemberId = "100028368";//母订单的商户号
		
		String TxnAmt="100";//交易金额单位（分）


		String ReturnUrl="";//交易结果异步通知接收地址
		String TransId = "TID"+System.currentTimeMillis();//商户订单号

		Log.Write("子订单号："+TransId);
		
        String AesKey = FormatUtil.CreateAeskey();//商户自定义(可随机生成  AES key长度为=16位)
		String dgtl_envlp = "01|"+AesKey;//使用接收方的公钥加密后的对称密钥，并做Base64转码，明文01|对称密钥，01代表AES[密码商户自定义]
		Log.Write("密码dgtl_envlp："+dgtl_envlp);	
		dgtl_envlp = RsaCodingUtil.encryptByPubCerFile(SecurityUtil.Base64Encode(dgtl_envlp), cerpath);//公钥加密
		ProtocolNo = SecurityUtil.AesEncrypt(SecurityUtil.Base64Encode(ProtocolNo), AesKey);//先BASE64后进行AES加密
		Log.Write("签约协议号AES结果:"+ProtocolNo);
		
		String CardInfo="";//信用卡：信用卡有效期|安全码,借记卡：传空
		
		//暂不支持信用卡
		CardInfo = SecurityUtil.AesEncrypt(SecurityUtil.Base64Encode(CardInfo), AesKey);//先BASE64后进行AES加密

		Map<String,String> DateArry = new TreeMap<String,String>();
			DateArry.put("send_time", send_time);
			DateArry.put("msg_id", "TISN"+System.currentTimeMillis());//报文流水号
			DateArry.put("version", "4.0.0.0");
			DateArry.put("terminal_id", TerminalId);
			DateArry.put("txn_type", "138");//交易类型(参看：文档中《交易类型枚举》)
			DateArry.put("member_id", MemberId);
			DateArry.put("trans_id", TransId);
			DateArry.put("dgtl_envlp", dgtl_envlp);
			DateArry.put("protocol_no", ProtocolNo);//签约协议号（密文）
			DateArry.put("txn_amt", TxnAmt);//交易金额 [单位：分  例：1元则提交100]，此处注意数据类型的转转，建议使用BigDecimal类弄进行转换为字串
			
			DateArry.put("main_member_id", MainMemberId);
			DateArry.put("main_trans_id", MainTransId);
		 DateArry.put("return_url", ReturnUrl);//最多填写三个地址,不同地址用间使用‘|’分隔
		 
		 String SignVStr = FormatUtil.coverMap2String(DateArry);
		 Log.Write("SHA-1摘要字串："+SignVStr);
		 String signature = SecurityUtil.sha1X16(SignVStr, "UTF-8");//签名
		 Log.Write("SHA-1摘要结果："+signature);		
		 String Sign = SignatureUtils.encryptByRSA(signature, pfxpath, pfxpwd);
		 Log.Write("RSA签名结果："+Sign);		
		 DateArry.put("signature", Sign);//签名域
			
		 String PostString  = HttpUtil.RequestForm("https://vgw.baofoo.com/cutpayment/protocol/backTransRequest", DateArry);	
		 Log.Write("请求返回:"+PostString);
			
		 Map<String, String> ReturnData = FormatUtil.getParm(PostString);
			
		 if(!ReturnData.containsKey("signature")){
			 throw new Exception("缺少验签参数！");
		 }
		 String RSign=ReturnData.get("signature");
		 Log.Write("返回的验签值："+RSign);
		 ReturnData.remove("signature");//需要删除签名字段		
		 String RSignVStr = FormatUtil.coverMap2String(ReturnData);
		 Log.Write("返回SHA-1摘要字串："+RSignVStr);
		 String RSignature = SecurityUtil.sha1X16(RSignVStr, "UTF-8");//签名
		 Log.Write("返回SHA-1摘要结果："+RSignature);
			
		 if(SignatureUtils.verifySignature(cerpath,RSignature,RSign)){
			 Log.Write("Yes");//验签成功
		 }
		 if(!ReturnData.containsKey("resp_code")){
			 throw new Exception("缺少resp_code参数！");
		 }
		 if(ReturnData.get("resp_code").toString().equals("S")){
			 Log.Write("支付成功！");
		 }else if(ReturnData.get("resp_code").toString().equals("I")){	
			Log.Write("处理中！");
		 }else if(ReturnData.get("resp_code").toString().equals("F")){
			Log.Write("失败！");
		 }else{
			throw new Exception("反回异常！");//异常不得做为订单状态。
		 }
		
	}
}